//----------------------------------------------------------------------------------
// JDKClient
// 
//----------------------------------------------------------------------------------
CRunJDKClient.PARAM 				= 0;
CRunJDKClient.CND_LAST 				= 4;
CRunJDKClient.ADMIN_NEW_CONNECT 	= 1;
CRunJDKClient.ADMIN_DIS_CONNECT 	= 2;
CRunJDKClient.ADMIN_USER_MESSAGE 	= 3;
CRunJDKClient.ADMIN_USER_BINARY		= 4;
CRunJDKClient.QUEUE_MAX 			= 255;
CRunJDKClient.TIME_OUT_VALUE 		= 5000;
CRunJDKClient.STATUS_SERVER_NONE 	= -1;
CRunJDKClient.STATUS_CONNECTIONG	= 1;
CRunJDKClient.STATUS_CONNECT_OK 	= 2;
CRunJDKClient.STATUS_DISCONNECTED 	= 3;
CRunJDKClient.COM_CL_PING = 0;			
CRunJDKClient.COM_SV_PONG = 1;			
CRunJDKClient.COM_SV_OPEN = 2;			
CRunJDKClient.COM_CL_CLOSE = 3;			
CRunJDKClient.COM_SV_CLOSE = 4;			
CRunJDKClient.COM_FREE_MSG = 20;		
CRunJDKClient.COM_FREE_BIN = 21;		
CRunJDKClient.hand_shake_key = "azarl_soft_2019";
// ---------------------------------------------------------
CRunJDKClient.TEncoder = new TextEncoder();
CRunJDKClient.TDecoder = new TextDecoder();
CRunJDKClient.global = null;
function CRunJDKClient(){
	this.Event_Code = 0;
	this.Event_String = null;
	this.Receive_Type = 0;
	
	if( CRunJDKClient.global != null ){
		this.CLAdmin = CRunJDKClient.global;
		return;
	}
	// ---------------------------------
	this.CLAdmin = ({
		Init:function(){
			this.receiveCode = new Array( CRunJDKClient.QUEUE_MAX );
			this.receiveVal = new Array( CRunJDKClient.QUEUE_MAX );
			this.write_index = 0;
			this.read_index = 0;
			this.count_index = 0;
			this.timeout_time = 0;
			this.sv_con_id = -1;
			this.disconnect_flg = false;
			this.init_connect_flg = false;
			this.status_code = 0;
			this.loop = false;
			this.keyword = null;
			this.socket = null ;
			this.protocol = "ws";
			// BinPackSystem
			this.SendBuffer = ({
				Init:function(){
					this.buffer = new ArrayBuffer(512);
					this.buf = new Uint8Array(this.buffer);
					this.dv = new DataView( this.buffer );
					this.pos = 0;
				},
				clearBin:function(){
					this.pos = 0;
				},
				pushBinByte:function( val ){
					this.dv.setInt8( this.pos , val );
					this.pos += 1 ;
				},
				pushBinShort:function( val ){
					this.dv.setInt16( this.pos , val );
					this.pos += 2 ;
				},
				pushBinInt:function( val ){
					this.dv.setInt32( this.pos , val );
					this.pos += 4 ;
				},
				pushBinLong:function( val ){
					this.dv.setInt64( this.pos , val );
					this.pos += 8 ;
				},
				pushBinFloat:function( val ){
					this.dv.setFloat32( this.pos , val );
					this.pos += 4 ;
				},
				getBinStream:function(){
					return new Uint8Array( this.buffer , 0 , this.pos );
				}
			});
			this.SendBuffer.Init();
		},
		Release:function(){
			var i;
			if( this.socket != null ){
				this.connectionClose();
				this.socket = null;
			}
			for( i = 0 ; i < CRunJDKClient.QUEUE_MAX ; i++ ){
				this.receiveCode[i] = 0;
				this.receiveVal[i] = null;
			}
			this.receiveCode = null;
			this.receiveVal = null;
			this.write_index = 0;
			this.read_index	= 0;
			this.count_index = 0;
			this.loop = false;
		},
		Run:function(){
			var time = (new Date).getTime();
			if( this.init_connect_flg ){
				var t_base = this.timeout_time + CRunJDKClient.TIME_OUT_VALUE ;
				if( t_base < time ){
					this.sendPing();
				}else if( t_base - time < 0 ){
					console.log("server time out");
					this.connectionClose();
				}
			}
		},
		addEventQ:function( code , val ){
			this.receiveCode[ this.write_index ] = code;
			this.receiveVal[ this.write_index ] = val;
			this.write_index = (this.write_index + 1) % CRunJDKClient.QUEUE_MAX;
			this.count_index++;
		},
		sendMessage:function( msg ){
			this.send( CRunJDKClient.COM_FREE_MSG , CRunJDKClient.TEncoder['encode'](msg) );
		},
		sendBin:function(){
			this.send( CRunJDKClient.COM_FREE_BIN , this.SendBuffer.getBinStream() );
			this.clearBin();
		},
		getQueueCode:function(){
			return this.receiveCode[this.read_index];
		},
		getQueueVal:function(){
			return this.receiveVal[this.read_index];
		},
		// -----------------------------
		// bin packs
		// -----------------------------
		clearBin:function(){
			this.SendBuffer.clearBin();
		},
		pushBinByte:function( val ){
			this.SendBuffer.pushBinByte( val );
		},
		pushBinShort:function( val ){
			this.SendBuffer.pushBinShort( val );
		},
		pushBinInt:function( val ){
			this.SendBuffer.pushBinInt( val );
		},
		pushBinLong:function( val ){
			this.SendBuffer.pushBinLong( val );
		},
		pushBinFloat:function( val ){
			this.SendBuffer.pushBinFloat( val );
		},
		sendBin:function( msg ){
			this.send( CRunJDKClient.COM_FREE_BIN , this.SendBuffer.getBinStream() );
		},
		
		getBinByte:function( offset ){
			return this.Receive_DV.getInt8( offset );
		},
		getBinShort:function( offset ){
			return this.Receive_DV.getInt16( offset );
		},
		getBinInt:function( offset ){
			return this.Receive_DV.getInt32( offset );
		},
		getBinLong:function( offset ){
			return this.Receive_DV.getInt64( offset );
		},
		getBinFloat:function( offset ){
			return this.Receive_DV.getFloat32( offset );
		},
		getBinDouble:function( offset ){
			return this.Receive_DV.getFloat64( offset );
		},
		getRecieveBinSize:function(){
			return this.Receive_DV.byteLength;
		},
		// -----------------------------
		// mask
		toMask:function( buf ){
			if( this.keyword == null || buf == null )return ;
			for( var i = 0 ; i < buf.length ; i++ ){
				buf[i] = buf[i] ^ this.keyword[i % this.keyword.length];
			}
		},
		// -----------------------------
		addQueueCount:function(){
			if( this.count_index > 0 ){
				this.receiveCode[this.read_index] = 0;
				this.receiveVal[this.read_index] = null;
				this.read_index = ( this.read_index + 1 ) % CRunJDKClient.QUEUE_MAX;
				this.count_index--;
			}
		},
		getQueueCount:function(){
			return this.count_index;
		},
		openConnection:function( ip , port , key ){
			if( !this.init_connect_flg ){
				this.keyword = CRunJDKClient.TEncoder['encode']( key );
				this.status_code = CRunJDKClient.STATUS_CONNECTIONG;
				var address = this.protocol+"://"+ip+":"+port;
				this.disconnect_flg = false;
				this.socket = new WebSocket( address );
				this.socket._parent = this;
				this.socket['binaryType'] = "arraybuffer";
				this.socket.onopen = function(e){
					this._parent.loop = true;
					if( this._parent.keyword != "" ){
						var buf = CRunJDKClient.TEncoder['encode'](CRunJDKClient.hand_shake_key);
						this._parent.toMask( buf );
						this.send( buf );
						buf = null;
					}
				};
				this.socket.onmessage = function(e){
					this._parent.updateClientTimestamp();
					var buf = new Uint8Array( e.data );
					this._parent.toMask( buf );
					var i = buf[0];
					if( i == CRunJDKClient.COM_SV_OPEN ){
						this._parent.init_connect_flg = true;
						this._parent.status_code = CRunJDKClient.STATUS_CONNECT_OK;
						this._parent.sv_con_id = ( buf[4] | (buf[3]<<8) | (buf[2]<<16) | (buf[1]<<24));
						this._parent.addEventQ( CRunJDKClient.ADMIN_NEW_CONNECT , String( this._parent.sv_con_id ) );
					}else if(i == CRunJDKClient.COM_SV_PONG ){
					}else if(i == CRunJDKClient.COM_SV_CLOSE ){
						this._parent.connectionClose();
					}else if(i == CRunJDKClient.COM_FREE_MSG ){
						if( buf.length > 0 ){
							this._parent.addEventQ( CRunJDKClient.ADMIN_USER_MESSAGE , CRunJDKClient.TDecoder['decode'](buf.slice( 1 , buf.length )) );
							str = null;
						}
					}else if(i == CRunJDKClient.COM_FREE_BIN ){
						if( buf.length > 0 )
							this._parent.addEventQ( CRunJDKClient.ADMIN_USER_BINARY , buf.slice( 1 , buf.length ) );
					}
					buf = null;
				};
				this.socket.onerror = function(e){
					alert("socket error");
					this._parent.status_code = CRunJDKClient.STATUS_SERVER_NONE;
				};
				this.socket.onclose = function(e){
					this._parent.connectionClose();
				};
			}
		},
		closeConnection:function(){
			if( this.socket != null ){
				this.send( CRunJDKClient.COM_CL_CLOSE , null );
				this.connectionClose();
			}
		},
		getConnectionID:function(){
			return this.sv_con_id;
		},
		clientErrorCheck:function(){
			if( this.loop == false ){
				return 1;
			}
			return 0;
		},
		lastConnectionState:function(){
			return this.status_code;
		},
		getLocalIP:function(){
			return "can't acquire with js";
		},
		// cl
		updateClientTimestamp:function(){
			this.timeout_time = (new Date).getTime();
		},
		connectionClose:function(){
			if( !this.disconnect_flg ){
				this.disconnect_flg = true;
				if( this.init_connect_flg ){
					this.addEventQ( CRunJDKClient.ADMIN_DIS_CONNECT , String( this.sv_con_id ) );
					this.init_connect_flg = false;
					this.sv_con_id = -1;
				}
			}
			this.status_code = CRunJDKClient.STATUS_DISCONNECTED;
		},
		send:function( code , buf ){
			var size = 1;
			if( buf != null )size += buf.length;
			var sbuf = new Uint8Array( size );
			sbuf.set( [code],0 );
			if( buf != null )sbuf.set( buf , 1 );
			this.toMask( sbuf );
			
			if( this.socket != null )this.socket.send( sbuf );
			this.updateClientTimestamp();
		},
		sendPing:function(){
			this.updateClientTimestamp();
			if( this.socket != null )this.send( CRunJDKClient.COM_CL_PING , null );
		}
	});
	this.CLAdmin.Init();
	CRunJDKClient.global = this.CLAdmin;
}

// Extention
CRunJDKClient.prototype = CServices.extend(new CRunExtension(),{
	getNumberOfConditions: function (){
		return CRunJDKClient.CND_LAST;
	},
	createRunObject: function (file, cob, version){
    	this.Event_Code = 0;
    	this.Event_String = null;
    	return true;
	},
	destroyRunObject: function (bFast){
	},
	handleRunObject: function (){
		if( this.CLAdmin != null ){
			if( this.Event_String != null )
				this.Event_String = null;
			if( this.Event_Code != 0 ){
				this.Event_Code = 0;
				this.Receive_Type = 0;
				this.CLAdmin.addQueueCount();
			}
			if( this.CLAdmin.getQueueCount() > 0 ){
				this.Event_Code		= this.CLAdmin.getQueueCode();
				if( this.Event_Code == 3 ){
					this.Event_String	= this.CLAdmin.getQueueVal();
					this.Receive_Type = 1;
				}else if( this.Event_Code == 4 ){
					this.Receive_Type = 2;
					this.CLAdmin.Receive_DV = new DataView( this.CLAdmin.getQueueVal().buffer );
				}
				if( this.Event_Code == 1 )this.ho.generateEvent(0, 0);
				if( this.Event_Code == 2 )this.ho.generateEvent(1, 0);
				if( this.Event_Code == 3 )this.ho.generateEvent(2, 0);
				if( this.Event_Code == 4 )this.ho.generateEvent(3, 0);
			}
			this.CLAdmin.Run();
		}
		return 0;
	},
	// -------------------------------------------------
	// condition
	// -------------------------------------------------
	condition: function (num, cnd){
		switch (num){
			case 0:
				if (this.Event_Code == 1) return true;
			case 1:
				if (this.Event_Code == 2) return true;
			case 2:
				if (this.Event_Code == 3) return true;
			case 3:
				if (this.Event_Code == 4) return true;
		}
		return false;
	},
	// -------------------------------------------------
	// Actions
	// -------------------------------------------------
	action: function (num, act){
		switch (num){
			case 0:
				this.CLAdmin.openConnection(act.getParamExpString(this.rh, 0), act.getParamExpression(this.rh, 1), act.getParamExpString(this.rh, 2));
				break;
			case 1:
				this.CLAdmin.closeConnection();
				this.CLAdmin.protocol = "ws";
				break;
			case 2:
				this.CLAdmin.sendMessage(act.getParamExpString(this.rh, 0));
				break;
			case 3:
				break;
			case 4:
				this.CLAdmin.clearBin();
				break;
			case 5:
				this.CLAdmin.pushBinByte(act.getParamExpression(this.rh, 0));
				break;
			case 6:
				this.CLAdmin.pushBinShort(act.getParamExpression(this.rh, 0));
				break;
			case 7:
				this.CLAdmin.pushBinInt(act.getParamExpression(this.rh, 0));
				break;
			case 8:
				this.CLAdmin.pushBinLong(act.getParamExpression(this.rh, 0));
				break;
			case 9:
				this.CLAdmin.pushBinFloat(act.getParamExpression(this.rh, 0));
				break;
			case 10:
				this.CLAdmin.pushBinDouble(act.getParamExpression(this.rh, 0));
				break;
			case 11:
				this.CLAdmin.sendBin();
				break;
			case 14:
				this.CLAdmin.protocol = "wss";
				break;
		}
	},
	// -------------------------------------------------
	// expression
	// -------------------------------------------------
	expression: function (num){
		switch (num){
			case 0:
				return this.CLAdmin.getConnectionID();
			case 1:
				if(this.Receive_Type == 1)return this.Event_String;
				return "";
			case 2:
			    return this.CLAdmin.clientErrorCheck();
			case 3:
				return this.CLAdmin.lastConnectionState();
			case 4:
				return this.CLAdmin.getLocalIP();
			case 5:
				return this.Receive_Type;
			case 6:
				if(this.Receive_Type == 2)return this.CLAdmin.getRecieveBinSize();
			case 7:
				if(this.Receive_Type == 2)return this.CLAdmin.getBinByte(this.ho.getExpParam());
			case 8:
				if(this.Receive_Type == 2)return this.CLAdmin.getBinShort(this.ho.getExpParam());
			case 9:
				if(this.Receive_Type == 2)return this.CLAdmin.getBinInt(this.ho.getExpParam());
			case 10:
				if(this.Receive_Type == 2)return this.CLAdmin.getBinLong(this.ho.getExpParam());
			case 11:
				if(this.Receive_Type == 2)return this.CLAdmin.getBinFloat(this.ho.getExpParam());
			case 12:
				if(this.Receive_Type == 2)return this.CLAdmin.getBinDouble(this.ho.getExpParam());
			
		}
		return 0;
	}
});
// ---------------------------------------------------------
